"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function () { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var SchemaDirectiveVisitor = require('graphql-tools').SchemaDirectiveVisitor;
var graphql_1 = require("graphql");
var asyncRedis = require('async-redis');
var client = asyncRedis.createClient();
var rateLimiter_1 = require("./rateLimiter");
var throttler_1 = require("./throttler");
var timeFrameMultiplier_1 = require("./timeFrameMultiplier");
var kikstart_graphql_client_1 = require("kikstart-graphql-client");
var graphqlQueries_1 = require("./graphqlQueries");

// Create paths for both local testing and production. We only need to use these for triggering operations from nodejs.

// Here we check to see if the user has signed up for website. If they have, they should have entered their token as their userID in their server file to establish a connection.
function portara(userID) {
    var userSettings = {}; // update to be staging branch settings
    var graphQLClient = new kikstart_graphql_client_1.GraphQLClient({
        // url: 'http://portara-web.herokuapp.com/graphql',
        // wsUrl: 'wss://portara-web.herokuapp.com/graphql',
        url: 'http://localhost:4000/graphql',
        wsUrl: 'ws://localhost:4000/graphql'
    });
    if (userID) {
        graphQLClient.runSubscription(graphqlQueries_1.subscr, { userID: userID }).subscribe({
            next: function (res) {
                // Once a subscription is successfully established, we update userSettings to reflect what's in the database
                userSettings[res.data.portaraSettings.name] = res.data.portaraSettings;
            },
            error: function (error) { return console.error('error', error); }
        });
    }
    // Portara directive class
    return /** @class */ (function (_super) {
        __extends(portaraDirective, _super);
        function portaraDirective() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        // This error message is only for generating a response to a client when they exceed their limit (not for any other kind of errors)
        portaraDirective.prototype.generateErrorMessage = function (limit, per, name, ip) {
            return __awaiter(this, void 0, void 0, function () {
                var timeLeft, error;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, client.ttl(ip + "_" + name)];
                        case 1:
                            timeLeft = _a.sent();
                            error = "You have exceeded the request limit of " + limit + " for the type(s) '" + name + "' . You have " + timeLeft + " seconds left until the next request can be made.";
                            return [2 /*return*/, error];
                    }
                });
            });
        };
        //FIELD_DEFINITION directive
        portaraDirective.prototype.visitFieldDefinition = function (field, details) {
            var _this = this;
            // console.log(this)
            var _a = this.args, limit = _a.limit, per = _a.per, throttle = _a.throttle;
            // we store the original resolver for later usage
            var _b = field.resolve, resolve = _b === void 0 ? graphql_1.defaultFieldResolver : _b;
            // similar to the subscription connection, we check if token has been entered. if it has, we run a mutation to update the database with our current directives. This is only because a user shouldn't lose their code settings if they've been using offline version of the tool and then decide to sign up online
            if (userID) {
                graphQLClient.runMutation(graphqlQueries_1.initializerMutation, { userID: userID, name: field.name, limit: limit, per: per, throttle: throttle })["catch"](function (err) { return console.log(err); });
            }
            field.resolve = function () {
                var originalArgs = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    originalArgs[_i] = arguments[_i];
                }
                return __awaiter(_this, void 0, void 0, function () {
                    var object, args, context, info, underLimit, perNum, perWord, throttled, error;
                    var _a, _b;
                    return __generator(this, function (_c) {
                        switch (_c.label) {
                            case 0:
                                object = originalArgs[0], args = originalArgs[1], context = originalArgs[2], info = originalArgs[3];
                                // if we've successfully pulled data from db, we update the userSettings and use those instead of original args
                                // console.log(userID, userSettings)
                                if (userSettings[info.fieldName]) {
                                    limit = userSettings[info.fieldName].limit;
                                    per = userSettings[info.fieldName].per;
                                    throttle = userSettings[info.fieldName].throttle;
                                }
                                return [4 /*yield*/, rateLimiter_1["default"](limit, per, context.req.ip, info.fieldName)];
                            case 1:
                                underLimit = _c.sent();
                                perNum = parseFloat((_a = throttle.match(/\d+/g)) === null || _a === void 0 ? void 0 : _a.toString());
                                perWord = (_b = throttle
                                    .match(/[a-zA-Z]+/g)) === null || _b === void 0 ? void 0 : _b.toString().toLowerCase();
                                throttled = timeFrameMultiplier_1["default"](perWord) * perNum;
                                if (!(!underLimit && throttled)) return [3 /*break*/, 3];
                                return [4 /*yield*/, throttler_1["default"](throttled)];
                            case 2:
                                _c.sent();
                                return [2 /*return*/, resolve.apply(void 0, originalArgs)];
                            case 3:
                                if (!underLimit) return [3 /*break*/, 4];
                                return [2 /*return*/, resolve.apply(void 0, originalArgs)];
                            case 4:
                                if (!!underLimit) return [3 /*break*/, 6];
                                return [4 /*yield*/, this.generateErrorMessage(limit, per, info.fieldName, context.req.ip)];
                            case 5:
                                error = _c.sent();
                                return [2 /*return*/, new Error(error)];
                            case 6: return [2 /*return*/];
                        }
                    });
                });
            };
        };
        // OBJECT directive
        portaraDirective.prototype.visitObject = function (type) {
            var _this = this;
            var _a = this.args, limit = _a.limit, per = _a.per, throttle = _a.throttle;
            var typeAsString = type.toString();
            // similar to the subscription connection, we check if token has been entered. if it has, we run a mutation to update the database with our current directives. This is only because a user shouldn't lose their code settings if they've been using offline version of the tool and then decide to sign up online
            if (userID) {
                graphQLClient.runMutation(graphqlQueries_1.initializerMutation, { userID: userID, name: type, limit: limit, per: per, throttle: throttle })["catch"](function (err) { return console.log(err); });
            }
            var fields = type.getFields();
            Object.values(fields).forEach(function (field) {
                var _a = field.resolve, resolve = _a === void 0 ? graphql_1.defaultFieldResolver : _a;
                if (!field.astNode.directives.some(function (directive) { return directive.name.value === 'portara'; })) {
                    field.resolve = function () {
                        var originalArgs = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            originalArgs[_i] = arguments[_i];
                        }
                        return __awaiter(_this, void 0, void 0, function () {
                            var object, args, context, info, underLimit, perNum, perWord, throttled, error;
                            var _a, _b;
                            return __generator(this, function (_c) {
                                switch (_c.label) {
                                    case 0:
                                        object = originalArgs[0], args = originalArgs[1], context = originalArgs[2], info = originalArgs[3];
                                        // if we've successfully pulled data from db, we update the userSettings and use those instead of original args        
                                        if (userSettings[typeAsString]) {
                                            limit = userSettings[typeAsString].limit;
                                            per = userSettings[typeAsString].per;
                                            throttle = userSettings[typeAsString].throttle;
                                        }
                                        return [4 /*yield*/, rateLimiter_1["default"](limit, per, context.req.ip, type.toString())];
                                    case 1:
                                        underLimit = _c.sent();
                                        perNum = parseFloat((_a = throttle.match(/\d+/g)) === null || _a === void 0 ? void 0 : _a.toString());
                                        perWord = (_b = throttle
                                            .match(/[a-zA-Z]+/g)) === null || _b === void 0 ? void 0 : _b.toString().toLowerCase();
                                        throttled = timeFrameMultiplier_1["default"](perWord) * perNum;
                                        if (!(!underLimit && throttled)) return [3 /*break*/, 3];
                                        return [4 /*yield*/, throttler_1["default"](throttled)];
                                    case 2:
                                        _c.sent();
                                        return [2 /*return*/, resolve.apply(void 0, originalArgs)];
                                    case 3:
                                        if (!underLimit) return [3 /*break*/, 4];
                                        return [2 /*return*/, resolve.apply(void 0, originalArgs)];
                                    case 4:
                                        if (!!underLimit) return [3 /*break*/, 6];
                                        return [4 /*yield*/, this.generateErrorMessage(limit, per, type.toString(), context.req.ip)];
                                    case 5:
                                        error = _c.sent();
                                        return [2 /*return*/, new Error(error)];
                                    case 6: return [2 /*return*/];
                                }
                            });
                        });
                    };
                }
            });
        };
        return portaraDirective;
    }(SchemaDirectiveVisitor));
}
exports["default"] = portara;
